        .MODEL  LARGE
        .STACK  400h
        .DATA
i8080AF LABEL   WORD
i8080F  DB      44h
i8080A  DB      00h
i8080BC LABEL   WORD
i8080C  DB      00h
i8080B  DB      00h
i8080DE LABEL   WORD
i8080E  DB      00h
i8080D  DB      00h
i8080HL LABEL   WORD
i8080L  DB      00h
i8080H  DB      00h
i8080PC DW      0000h
i8080SP DW      0000h
i8080IM DB      00h
OP      DB      00h
FHANDLE DW      0000h
HHANDLE DW      0000h
HDRNAME DB      13 dup(00h)
RNAME   DB      13 dup(00h)
        DB      13 dup(00h)
        DB      13 dup(00h)
        DB      13 dup(00h)
        DB      13 dup(00h)
        DB      13 dup(00h)
RLOC    DW      0000h
        DW      0000h
        DW      0000h
        DW      0000h
        DW      0000h
        DW      0000h
ROMNUM  DW      0000h
RSIZE   DW      0000h
IOARRAY DB      256 dup(00h)
BTMPIN  DB      00h
OUTARRY DB      256 dup(00h)
SHORTER DB      'is too short to work!',24h
NOEXIST DB      'doesn',27h,'t exist!',24h
NOFILEN DB      'You must include a filename!',24h
F2LONG  DB      'Filename is too long! 12 Characters maximum:',0Dh,0Ah
        DB      '       8 Characters maximum for main name',0Dh,0Ah
        DB      '       1 Character for period',0Dh,0Ah
        DB      '       3 Characters maximum for extention.',24h
ERRORO  DB      'Unknown error, program terminated.',24h
INSTRUC DB      'Emul80 Midway Arcade Emulator v1.0 (c) 2001 Ryan Holtz',0Dh,0Ah
        DB      'E-mail the creator at: mega64man1@hotmail.com',0Dh,0Ah
        DB      '       USAGE:          Emul80 <filename>',0Dh,0Ah
        DB      'Please note, there must be an existing header file for the filename.',0Dh,0Ah,24h
NOHEADR DB      'There is no header file for that game! Please create or download one.',24h
HDRSHRT DB      'The header file must be at least 256 bytes in length!',24h
TEMPBYT DB      00h
ROMPTR  DW      0000h
ASCNUM  DB      4 dup(00h),24h
TEMPWRD DW      0000h
INCLUDE REVERSE.INC
IEN     DB      00h
IRQ     DB      10h
ISK     DB      00h
HALTED  DB      00h
EIINT   DB      00h
COUNTER DD      0000411Ah
REGS    DB      'PC-       AF-       BC-       DE-    ',0Dh,0Ah
        DB      'HL-       SP-       OP-       CY-    ',0Dh,0Ah
        DB      'IE-       IQ-       IS-       HT-    ',24h
INCOUNT DW      0400h
KEYPRES DB      00h
OUTOFF  DW      OFFSET  OUTARRY
INOFF   DW      OFFSET  IOARRAY
SHFTOUT DW      0000h
BTMPOUT DW      0000h
BTMPTMP DB      00h
INCLUDE JUMPTBL.INC

MEMARRY SEGMENT
MAINMEM DB      16384 dup(00h)
        DB      16384 dup(00h)
        DB      16384 dup(00h)
        DB      16384 dup(00h)
MEMARRY ENDS

.386
.CODE
MAIN    PROC    NEAR
        ASSUME  ES:MEMARRY
        INCLUDE GENERIC.MAC
        INCLUDE 8080.MAC
        INCLUDE TEXT.MAC
        INCLUDE GRAPH.MAC
        INCLUDE REVERSE.MAC
        INCLUDE PORT.MAC
        MOV     AX,@data
        MOV     DS,AX
        CALL    GETHEDR
        CALL    READHDR
        MOV     AX,MEMARRY
        MOV     ES,AX
        SETMODE 0Fh
        CALL    RST8080
        CALL    RR
        CALL    GO8080
        ENDPROG
MAIN    ENDP

RST8080 PROC    NEAR
        LOCALS
        MOV     CX,0FFFFh
        MOV     BX,0000h
        MOV     AX,0000h
@@EraseMem:
        MOV     BYTE PTR ES:[BX],AL
        INC     BX
        LOOP    @@EraseMem
        MOV     i8080A,00h
        MOV     i8080B,00h
        MOV     i8080C,00h
        MOV     i8080D,00h
        MOV     i8080E,00h
        MOV     i8080F,00h
        MOV     i8080H,00h
        MOV     i8080L,00h
        MOV     i8080PC,0000h
        MOV     i8080SP,0000h     
        RET
RST8080 ENDP

GO8080  PROC    NEAR
        LOCALS
@@Do8080:
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     OP,AL
        ;CALL    DREGS
        ;MOV     AH,08h
        ;INT     21h
        ;CMP     AL,71h
        ;JE      @@Done8080
        CALL    DECODE
        INC     i8080PC
        CMP     COUNTER,00000000h
        JLE     @@UpdateIt
        JMP     @@Do8080
@@UpdateIt:
        CALL    UPDATE
        CALL    DOINT
        XOR     IRQ,18h
        MOV     AH,11h
        INT     16h
        JZ      @@NoKey
        XOR     IRQ,18h
        MOV     AH,11h
        INT     16h
        JZ      @@NoKey
        MOV     AH,10h
        INT     16h
        CMP     AL,51h
        JE      @@Done8080
        CMP     AL,71h
        JE      @@Done8080
        MOV     COUNTER,0000411Ah
        JMP     @@Do8080
@@NoKey:
        MOV     COUNTER,0000411Ah
        JMP     @@Do8080
@@Done8080:
        RET
GO8080  ENDP

DECODE  PROC    NEAR
        LOCALS
        MOVZX   BX,OP
        SHL     BX,01h
        ADD     BX,OFFSET JTABLE
        JMP     [BX]
OP00h:                                  ; NOP
        SUB     COUNTER,0004h        
        RET
OP01h:                                  ; LXI B,nn
        INC     i8080PC        
        MOV     BX,i8080PC
        INC     i8080PC
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080BC,AX
        SUB     COUNTER,000Ah
        RET
OP02h:                                  ; STAX B
        MOV     AL,i8080A
        MOV     BX,i8080BC
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP03h:                                  ; INX B
        INC     i8080BC
        SUB     COUNTER,0005h
        RET
OP04h:                                  ; INR B                                 
        INC     i8080B
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP05h:                                  ; DCR B
        DEC     i8080B
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP06h:                                  ; MVI B,n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080B,AL
        SUB     COUNTER,0007h
        RET
OP07h:                                  ; RLC
        ROL     i8080A,01h
        CHECKC  i8080F
        SUB     COUNTER,0004h
        RET
OP08h:                                  ; Invalid                                
        SUB     COUNTER,0004h
        RET
OP09h:                                  ; DAD B
        MOV     CX,i8080BC
        ADD     i8080HL,CX
        HC      i8080F
        SUB     COUNTER,000Ah
        RET
OP0Ah:                                  ; LDAX B 
        MOV     BX,i8080BC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080A,AL
        SUB     COUNTER,0007h
        RET
OP0Bh:                                  ; DCX B   
        DEC     i8080BC
        SUB     COUNTER,0005h
        RET
OP0Ch:                                  ; INR C
        INC     i8080C
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET                                     
OP0Dh:                                  ; DCR C
        DEC     i8080C
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP0Eh:                                  ; MVI C,n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080C,AL
        SUB     COUNTER,0007h
        RET
OP0Fh:                                  ; RRC
        ROR     i8080A,01h
        CHECKC  i8080F
        SUB     COUNTER,0004h
        RET             
OP10h:                                  ; Invalid
        SUB     COUNTER,0008h
        RET
OP11h:                                  ; LXI D,nn
        INC     i8080PC
        MOV     BX,i8080PC
        INC     i8080PC
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080DE,AX
        SUB     COUNTER,000Ah
        RET
OP12h:                                  ; STAX D
        MOV     AL,i8080A
        MOV     BX,i8080DE
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP13h:                                  ; INX D
        INC     i8080DE
        SUB     COUNTER,0005h
        RET
OP14h:                                  ; INR D
        INC     i8080D
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP15h:                                  ; DCR D
        DEC     i8080D
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP16h:                                  ; MVI D,n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080D,AL
        SUB     COUNTER,0007h
        RET
OP17h:                                  ; RAL
        CY80_86 i8080F
        RCL     i8080A,01h
        CHECKC  i8080F
        SUB     COUNTER,0004h
        RET
OP18h:                                  ; Invalid
        SUB     COUNTER,0007h
        RET
OP19h:                                  ; DAD D
        MOV     AX,i8080DE
        ADD     i8080HL,AX
        HC      i8080F
        SUB     COUNTER,000Ah
        RET
OP1Ah:                                  ; LDAX D 
        MOV     BX,i8080DE
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080A,AL
        SUB     COUNTER,0007h
        RET
OP1Bh:                                  ; DCX D
        DEC     i8080DE
        SUB     COUNTER,0005h
        RET
OP1Ch:                                  ; INR E
        INC     i8080E
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP1Dh:                                  ; DCR E
        DEC     i8080E
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP1Eh:                                  ; MVI E,n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080E,AL
        SUB     COUNTER,0007h
        RET
OP1Fh:                                  ; RAR
        CY80_86 i8080F
        RCR     i8080A,01h
        CHECKC  i8080F
        SUB     COUNTER,0004h
        RET
OP20h:                                  ; Invalid
        SUB     COUNTER,0007h
        RET
OP21h:                                  ; LXI H,nn
        INC     i8080PC
        MOV     BX,i8080PC
        INC     i8080PC
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080HL,AX
        SUB     COUNTER,000Ah
        RET
OP22h:                                  ; SHLD aa
        INC     i8080PC
        MOV     BX,i8080PC
        INC     i8080PC
        MOV     BX,WORD PTR ES:[BX]
        MOV     AX,i8080HL
        WRITMEM AL
        INC     BX
        WRITMEM AH
        SUB     COUNTER,0010h
        RET
OP23h:                                  ; INX H
        INC     i8080HL
        SUB     COUNTER,0005h
        RET
OP24h:                                  ; INR H
        INC     i8080H
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP25h:                                  ; DCR H
        DEC     i8080H
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP26h:                                  ; MVI H,n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080H,AL
        SUB     COUNTER,0007h
        RET
OP27h:                                  ; DAA
        MOV     AH,i8080F
        SAHF
        DAA
        LAHF
        AND     AH,11010101B
        AND     i8080F,00101010B
        OR      i8080F,CH
        SUB     COUNTER,0004h
        RET
OP28h:                                  ; Invalid
        SUB     COUNTER,0007h
        RET
OP29h:                                  ; DAD H
        MOV     BX,i8080HL
        ADD     i8080HL,BX
        HC      i8080F
        SUB     COUNTER,000Ah
        RET
OP2Ah:                                  ; LHLD aa
        INC     i8080PC
        MOV     BX,i8080PC
        INC     i8080PC
        MOV     BX,WORD PTR ES:[BX]
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080HL,AX
        SUB     COUNTER,0010h
        RET
OP2Bh:                                  ; DCX H
        DEC     i8080HL
        SUB     COUNTER,0005h
        RET
OP2Ch:                                  ; INR L
        INC     i8080L
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP2Dh:                                  ; DCR L
        DEC     i8080L
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP2Eh:                                  ; MVI L,n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080L,AL
        SUB     COUNTER,0007h
        RET
OP2Fh:                                  ; CMA
        NOT     i8080A
        SUB     COUNTER,0004h
        RET
OP30h:                                  ; Invalid
        SUB     COUNTER,0004h
        RET
OP31h:                                  ; LXI SP,nn
        INC     i8080PC
        MOV     BX,i8080PC
        INC     i8080PC
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080SP,AX
        SUB     COUNTER,000Ah
        RET
OP32h:                                  ; STA aa
        INC     i8080PC
        MOV     BX,i8080PC
        INC     i8080PC
        MOV     BX,WORD PTR ES:[BX]
        MOV     AL,i8080A
        WRITMEM AL
        SUB     COUNTER,000Dh
        RET
OP33h:                                  ; INX SP
        INC     i8080SP
        SUB     COUNTER,0005h
        RET
OP34h:                                  ; INR M
        MOV     BX,i8080HL
        MOV     CL,BYTE PTR ES:[BX]
        INC     CL
        SZHP    i8080F
        WRITMEM CL
        SUB     COUNTER,000Ah
        RET
OP35h:                                  ; DCR M
        MOV     BX,i8080HL
        MOV     CL,BYTE PTR ES:[BX]
        DEC     CL
        SZHP    i8080F
        WRITMEM CL
        SUB     COUNTER,000Ah
        RET
OP36h:                                  ; MVI M,n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     BX,i8080HL
        WRITMEM AL
        SUB     COUNTER,000Ah
        RET
OP37h:                                  ; STC
        OR      i8080F,00000001B
        SUB     COUNTER,0004h
        RET
OP38h:                                  ; Invalid
        SUB     COUNTER,0007h
        RET
OP39h:                                  ; DAD SP
        MOV     BX,i8080SP
        ADD     i8080HL,BX
        HC      i8080F
        SUB     COUNTER,000Ah
        RET
OP3Ah:                                  ; LDA aa 
        INC     i8080PC
        MOV     BX,i8080PC
        INC     i8080PC
        MOV     BX,WORD PTR ES:[BX]
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080A,AL
        SUB     COUNTER,000Dh
        RET
OP3Bh:                                  ; DCX SP
        DEC     i8080SP
        SUB     COUNTER,0005h
        RET
OP3Ch:                                  ; INR A
        INC     i8080A
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP3Dh:                                  ; DCR A
        DEC     i8080A
        SZHP    i8080F
        SUB     COUNTER,0005h
        RET
OP3Eh:                                  ; MVI A,n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080A,AL
        SUB     COUNTER,0007h
        RET
OP3Fh:                                  ; CMC
        MOV     AL,i8080F
        AND     AL,00000001B
        NOT     AL
        AND     AL,00000001B
        AND     i8080F,11111110B
        OR      i8080F,AL
        SUB     COUNTER,0004h
        RET
OP40h:                                  ; MOV B,B
        MOVE    i8080B,i8080B
        SUB     COUNTER,0005h
        RET
OP41h:                                  ; MOV B,C
        MOVE    i8080B,i8080C
        SUB     COUNTER,0005h
        RET
OP42h:                                  ; MOV B,D
        MOVE    i8080B,i8080D
        SUB     COUNTER,0005h
        RET
OP43h:                                  ; MOV B,E
        MOVE    i8080B,i8080E
        SUB     COUNTER,0005h
        RET
OP44h:                                  ; MOV B,H
        MOVE    i8080B,i8080H
        SUB     COUNTER,0005h
        RET
OP45h:                                  ; MOV B,L
        MOVE    i8080B,i8080L
        SUB     COUNTER,0005h
        RET
OP46h:                                  ; MOV B,M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080B,AL
        SUB     COUNTER,0007h
        RET
OP47h:                                  ; MOV B,A
        MOVE    i8080B,i8080A
        SUB     COUNTER,0005h
        RET
OP48h:                                  ; MOV C,B
        MOVE    i8080C,i8080B
        SUB     COUNTER,0005h
        RET
OP49h:                                  ; MOV C,C
        MOVE    i8080C,i8080C
        SUB     COUNTER,0005h
        RET
OP4Ah:                                  ; MOV C,D
        MOVE    i8080C,i8080D
        SUB     COUNTER,0005h
        RET
OP4Bh:                                  ; MOV C,E
        MOVE    i8080C,i8080E
        SUB     COUNTER,0005h
        RET
OP4Ch:                                  ; MOV C,H
        MOVE    i8080C,i8080H
        SUB     COUNTER,0005h
        RET
OP4Dh:                                  ; MOV C,L
        MOVE    i8080C,i8080L
        SUB     COUNTER,0005h
        RET
OP4Eh:                                  ; MOV C,M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080C,AL
        SUB     COUNTER,0007h
        RET
OP4Fh:                                  ; MOV C,A
        MOVE    i8080C,i8080A
        SUB     COUNTER,0005h
        RET
OP50h:                                  ; MOV D,B
        MOVE    i8080D,i8080B
        SUB     COUNTER,0005h
        RET
OP51h:                                  ; MOV D,C
        MOVE    i8080D,i8080C
        SUB     COUNTER,0005h
        RET
OP52h:                                  ; MOV D,D
        MOVE    i8080D,i8080D
        SUB     COUNTER,0005h
        RET
OP53h:                                  ; MOV D,E
        MOVE    i8080D,i8080E
        SUB     COUNTER,0005h
        RET
OP54h:                                  ; MOV D,H
        MOVE    i8080D,i8080H
        SUB     COUNTER,0005h
        RET
OP55h:                                  ; MOV D,L 
        MOVE    i8080D,i8080L
        SUB     COUNTER,0005h
        RET
OP56h:                                  ; MOV D,M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080D,AL
        SUB     COUNTER,0007h
        RET
OP57h:                                  ; MOV D,A
        MOVE    i8080D,i8080A
        SUB     COUNTER,0005h
        RET
OP58h:                                  ; MOV E,B
        MOVE    i8080E,i8080B
        SUB     COUNTER,0005h
        RET
OP59h:                                  ; MOV E,C
        MOVE    i8080E,i8080C
        SUB     COUNTER,0005h
        RET
OP5Ah:                                  ; MOV E,D
        MOVE    i8080E,i8080D
        SUB     COUNTER,0005h
        RET
OP5Bh:                                  ; MOV E,E
        MOVE    i8080E,i8080E
        SUB     COUNTER,0005h
        RET
OP5Ch:                                  ; MOV E,H
        MOVE    i8080E,i8080H
        SUB     COUNTER,0005h
        RET
OP5Dh:                                  ; MOV E,L
        MOVE    i8080E,i8080L
        SUB     COUNTER,0005h
        RET
OP5Eh:                                  ; MOV E,M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080E,AL
        SUB     COUNTER,0007h
        RET
OP5Fh:                                  ; MOV E,A
        MOVE    i8080E,i8080A
        SUB     COUNTER,0005h
        RET
OP60h:                                  ; MOV H,B
        MOVE    i8080H,i8080B
        SUB     COUNTER,0005h
        RET
OP61h:                                  ; MOV H,C
        MOVE    i8080H,i8080C
        SUB     COUNTER,0005h
        RET
OP62h:                                  ; MOV H,D
        MOVE    i8080H,i8080D
        SUB     COUNTER,0005h
        RET
OP63h:                                  ; MOV H,E
        MOVE    i8080H,i8080E
        SUB     COUNTER,0005h
        RET
OP64h:                                  ; MOV H,H
        MOVE    i8080H,i8080H
        SUB     COUNTER,0005h
        RET
OP65h:                                  ; MOV H,L
        MOVE    i8080H,i8080L
        SUB     COUNTER,0005h
        RET
OP66h:                                  ; MOV H,M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080H,AL
        SUB     COUNTER,0007h
        RET
OP67h:                                  ; MOV H,A
        MOVE    i8080H,i8080A
        SUB     COUNTER,0005h
        RET
OP68h:                                  ; MOV L,B
        MOVE    i8080L,i8080B
        SUB     COUNTER,0005h
        RET
OP69h:                                  ; MOV L,C
        MOVE    i8080L,i8080C
        SUB     COUNTER,0005h
        RET
OP6Ah:                                  ; MOV L,D
        MOVE    i8080L,i8080D
        SUB     COUNTER,0005h
        RET
OP6Bh:                                  ; MOV L,E
        MOVE    i8080L,i8080E
        SUB     COUNTER,0005h
        RET
OP6Ch:                                  ; MOV L,H
        MOVE    i8080L,i8080H
        SUB     COUNTER,0005h
        RET
OP6Dh:                                  ; MOV L,L
        MOVE    i8080L,i8080L
        SUB     COUNTER,0005h
        RET
OP6Eh:                                  ; MOV L,M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080L,AL
        SUB     COUNTER,0007h
        RET
OP6Fh:                                  ; MOV L,A
        MOVE    i8080L,i8080A
        SUB     COUNTER,0005h
        RET
OP70h:                                  ; MOV M,B
        MOV     BX,i8080HL
        MOV     AL,i8080B
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP71h:                                  ; MOV M,C
        MOV     BX,i8080HL
        MOV     AL,i8080C
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP72h:                                  ; MOV M,D
        MOV     BX,i8080HL
        MOV     AL,i8080D
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP73h:                                  ; MOV M,E
        MOV     BX,i8080HL
        MOV     AL,i8080E
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP74h:                                  ; MOV M,H
        MOV     BX,i8080HL
        MOV     AL,i8080H
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP75h:                                  ; MOV M,L
        MOV     BX,i8080HL
        MOV     AL,i8080L
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP76h:                                  ; HLT
        MOV     HALTED,0FFh
        DEC     i8080PC
        SUB     COUNTER,0004h
        RET
OP77h:                                  ; MOV M,A
        MOV     BX,i8080HL
        MOV     AL,i8080A
        WRITMEM AL
        SUB     COUNTER,0007h
        RET
OP78h:                                  ; MOV A,B
        MOVE    i8080A,i8080B
        SUB     COUNTER,0005h
        RET
OP79h:                                  ; MOV A,C
        MOVE    i8080A,i8080C
        SUB     COUNTER,0005h
        RET
OP7Ah:                                  ; MOV A,D
        MOVE    i8080A,i8080D
        SUB     COUNTER,0005h
        RET
OP7Bh:                                  ; MOV A,E
        MOVE    i8080A,i8080E
        SUB     COUNTER,0005h
        RET
OP7Ch:                                  ; MOV A,H
        MOVE    i8080A,i8080H
        SUB     COUNTER,0005h
        RET
OP7Dh:                                  ; MOV A,L
        MOVE    i8080A,i8080L
        SUB     COUNTER,0005h
        RET
OP7Eh:                                  ; MOV A,M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        MOV     i8080A,AL
        SUB     COUNTER,0007h
        RET
OP7Fh:                                  ; MOV A,A
        MOVE    i8080A,i8080A
        SUB     COUNTER,0005h
        RET
OP80h:                                  ; ADD B
        ADDREG  i8080A,i8080B
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP81h:                                  ; ADD C
        ADDREG  i8080A,i8080C
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP82h:                                  ; ADD D
        ADDREG  i8080A,i8080D
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP83h:                                  ; ADD E
        ADDREG  i8080A,i8080E
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP84h:                                  ; ADD H
        ADDREG  i8080A,i8080H
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP85h:                                  ; ADD L
        ADDREG  i8080A,i8080L
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP86h:                                  ; ADD M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        ADD     i8080A,AL
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OP87h:                                  ; ADD A
        ADDREG  i8080A,i8080A
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP88h:                                  ; ADC B
        ADCREG  i8080A,i8080B,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP89h:                                  ; ADC C
        ADCREG  i8080A,i8080C,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP8Ah:                                  ; ADC D
        ADCREG  i8080A,i8080D,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP8Bh:                                  ; ADC E
        ADCREG  i8080A,i8080E,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP8Ch:                                  ; ADC H
        ADCREG  i8080A,i8080H,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP8Dh:                                  ; ADC L 
        ADCREG  i8080A,i8080L,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP8Eh:                                  ; ADC M
        MOV     BX,i8080HL
        MOV     DL,BYTE PTR ES:[BX]
        MOV     CL,i8080F
        AND     CL,00000001B
        ADD     DL,CL
        ADD     i8080A,DL
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OP8Fh:                                  ; ADC A
        ADCREG  i8080A,i8080A,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP90h:                                  ; SUB B
        SUBREG  i8080A,i8080B
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP91h:                                  ; SUB C
        SUBREG  i8080A,i8080C
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP92h:                                  ; SUB D
        SUBREG  i8080A,i8080D
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP93h:                                  ; SUB E
        SUBREG  i8080A,i8080E
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP94h:                                  ; SUB H
        SUBREG  i8080A,i8080H
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP95h:                                  ; SUB L
        SUBREG  i8080A,i8080L
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP96h:                                  ; SUB M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        SUB     i8080A,AL
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OP97h:                                  ; SUB A
        SUBREG  i8080A,i8080A
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP98h:                                  ; SBB B
        SBBREG  i8080A,i8080B,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP99h:                                  ; SBB C
        SBBREG  i8080A,i8080C,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP9Ah:                                  ; SBB D
        SBBREG  i8080A,i8080D,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP9Bh:                                  ; SBB E
        SBBREG  i8080A,i8080E,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP9Ch:                                  ; SBB H
        SBBREG  i8080A,i8080H,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP9Dh:                                  ; SBB L
        SBBREG  i8080A,i8080L,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OP9Eh:                                  ; SBB M
        MOV     BX,i8080HL
        MOV     DL,BYTE PTR ES:[BX]
        MOV     CL,i8080F
        AND     CL,00000001B
        ADD     DL,CL
        CHECKC  i8080F
        SUB     i8080A,DL
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OP9Fh:                                  ; SBB A
        SBBREG  i8080A,i8080A,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0004h
        RET
OPA0h:                                  ; ANA B
        ANAREG  i8080A,i8080B,i8080F        
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET                                    
OPA1h:                                  ; ANA C
        ANAREG  i8080A,i8080C,i8080F        
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPA2h:                                  ; ANA D
        ANAREG  i8080A,i8080D,i8080F        
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPA3h:                                  ; ANA E
        ANAREG  i8080A,i8080E,i8080F        
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPA4h:                                  ; ANA H
        ANAREG  i8080A,i8080H,i8080F        
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPA5h:                                  ; ANA L
        ANAREG  i8080A,i8080L,i8080F        
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPA6h:                                  ; ANA M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        AND     i8080A,AL
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0007h
        RET
OPA7h:                                  ; ANA A
        ANAREG  i8080A,i8080A,i8080F        
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPA8h:                                  ; XRA B
        XRAREG  i8080A,i8080B,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPA9h:                                  ; XRA C
        XRAREG  i8080A,i8080C,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPAAh:                                  ; XRA D
        XRAREG  i8080A,i8080D,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPABh:                                  ; XRA E
        XRAREG  i8080A,i8080E,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPACh:                                  ; XRA H
        XRAREG  i8080A,i8080H,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPADh:                                  ; XRA L
        XRAREG  i8080A,i8080L,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPAEh:                                  ; XRA M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        XOR     i8080A,AL
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPAFh:                                  ; XRA A
        XRAREG  i8080A,i8080A,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPB0h:                                  ; ORA B
        ORAREG  i8080A,i8080B,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPB1h:                                  ; ORA C
        ORAREG  i8080A,i8080C,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPB2h:                                  ; ORA D
        ORAREG  i8080A,i8080D,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPB3h:                                  ; ORA E
        ORAREG  i8080A,i8080E,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPB4h:                                  ; ORA H
        ORAREG  i8080A,i8080H,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPB5h:                                  ; ORA L 
        ORAREG  i8080A,i8080L,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPB6h:                                  ; ORA M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        OR      i8080A,AL
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0007h
        RET
OPB7h:                                  ; ORA A
        ORAREG  i8080A,i8080A,i8080F
        SZP     i8080F
        CLEARHC i8080F
        SUB     COUNTER,0004h
        RET
OPB8h:                                  ; CMP B
        CMPREG  i8080A,i8080B,i8080F
        SUB     COUNTER,0004h
        RET
OPB9h:                                  ; CMP C
        CMPREG  i8080A,i8080C,i8080F
        SUB     COUNTER,0004h
        RET
OPBAh:                                  ; CMP D
        CMPREG  i8080A,i8080D,i8080F
        SUB     COUNTER,0004h
        RET
OPBBh:                                  ; CMP E
        CMPREG  i8080A,i8080E,i8080F
        SUB     COUNTER,0004h
        RET
OPBCh:                                  ; CMP H
        CMPREG  i8080A,i8080H,i8080F
        SUB     COUNTER,0004h
        RET
OPBDh:                                  ; CMP L
        CMPREG  i8080A,i8080L,i8080F
        SUB     COUNTER,0004h
        RET
OPBEh:                                  ; CMP M
        MOV     BX,i8080HL
        MOV     AL,BYTE PTR ES:[BX]
        CMP     i8080A,AL
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OPBFh:                                  ; CMP A
        CMPREG  i8080A,i8080A,i8080F
        SUB     COUNTER,0004h
        RET
OPC0h:                                  ; RNZ     
        MOV     AL,i8080F
        AND     AL,01000000B
        JNZ     OPC0Zero
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Bh
        RET
OPC0Zero:
        SUB     COUNTER,0005h
        RET
OPC1h:                                  ; POP B
        MOV     BX,i8080SP
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080BC,AX
        INC     i8080SP
        INC     i8080SP
        SUB     COUNTER,000Ah
        RET
OPC2h:                                  ; JNZ aa
        MOV     AL,i8080F
        AND     AL,01000000B
        JNZ     OPC2Zero
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPC2Zero:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Ah
        RET
OPC3h:                                  ; JMP aa
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPC4h:                                  ; CNZ aa
        MOV     AL,i8080F
        AND     AL,01000000B
        JNZ     OPC4Zero
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPC4Zero:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPC5h:                                  ; PUSH B
        MOV     BX,i8080SP
        MOV     AX,i8080BC
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        SUB     COUNTER,000Bh
        RET
OPC6h:                                  ; ADI n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        ADD     i8080A,AL
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OPC7h:                                  ; RST 0
        MOV     BX,i8080SP
        MOV     AX,i8080PC
        INC     AX
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        MOV     AX,0000h
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPC8h:                                  ; RZ
        MOV     AL,i8080F
        AND     AL,01000000B
        JZ      OPC8NZero
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Bh
        RET
OPC8NZero:
        SUB     COUNTER,0005h
        RET
OPC9h:                                  ; RET
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Ah
        RET
OPCAh:                                  ; JZ aa
        MOV     AL,i8080F
        AND     AL,01000000B
        JZ      OPCANZero
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPCANZero:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Ah
        RET
OPCBh:                                  ; Invalid
        SUB     COUNTER,0004h
        RET
OPCCh:                                  ; CZ aa
        MOV     AL,i8080F
        AND     AL,01000000B
        JZ      OPCCNZero
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPCCNZero:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPCDh:                                  ; CALL aa
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPCEh:                                  ; ACI n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     DL,BYTE PTR ES:[BX]
        ADCREG  i8080A,DL,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OPCFh:                                  ; RST 1
        MOV     BX,i8080SP
        MOV     AX,i8080PC
        INC     AX
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        MOV     AX,0008h
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPD0h:                                  ; RNC
        MOV     AL,i8080F
        AND     AL,00000001B
        JNZ     OPD0Carry
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Bh
        RET
OPD0Carry:
        SUB     COUNTER,0005h
        RET
OPD1h:                                  ; POP D
        MOV     BX,i8080SP
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080DE,AX
        INC     i8080SP
        INC     i8080SP
        SUB     COUNTER,000Ah
        RET
OPD2h:                                  ; JNC aa
        MOV     AL,i8080F
        AND     AL,00000001B
        JNZ     OPD2Carry
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPD2Carry:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Ah
        RET
OPD3h:                                  ; OUT n
        CMP     OP,0D3h
        JNE     OPD4h
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     DI,OUTOFF
        MOVZX   BX,BYTE PTR ES:[BX]
        CMP     BX,BTMPOUT
        JNE     OPD3NoBitmap
        MOV     AL,BYTE PTR DS:[BX+DI]
        MOV     BTMPTMP,AL
        MOV     AL,i8080A
        MOV     BYTE PTR DS:[BX+DI],AL
OPD3NoBitmap:
        MOV     AL,i8080A
        MOV     BYTE PTR DS:[BX+DI],AL
        SUB     COUNTER,000Ah
        RET
OPD4h:                                  ; CNC aa
        MOV     AL,i8080F
        AND     AL,00000001B
        JNZ     OPD4Carry
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPD4Carry:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPD5h:                                  ; PUSH D
        MOV     BX,i8080SP
        MOV     AX,i8080DE
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        SUB     COUNTER,000Bh
        RET
OPD6h:                                  ; SUI n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        SUB     i8080A,AL
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OPD7h:                                  ; RST 2
        MOV     BX,i8080SP
        MOV     AX,i8080PC
        INC     AX
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        MOV     AX,0010h
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPD8h:                                  ; RC
        MOV     AL,i8080F
        AND     AL,00000001B
        JZ      OPD8NCarry
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Bh
        RET
OPD8NCarry:
        SUB     COUNTER,0005h
        RET
OPD9h:                                  ; Invalid
        SUB     COUNTER,0004h
        RET
OPDAh:                                  ; JC aa
        MOV     AL,i8080F
        AND     AL,00000001B
        JZ      OPDANCarry
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPDANCarry:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Ah
        RET
OPDBh:                                  ; IN n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        CMP     AL,BTMPIN
        JNE     OPDBNoBitmap
        MOV     AX,OFFSET OUTARRY
        INBTMP  AX, SHFTOUT, BTMPOUT, BTMPTMP
        MOV     i8080A,AL
        SUB     COUNTER,000Ah
        RET
OPDBNoBitmap:
        MOVZX   BX,BYTE PTR ES:[BX]
        LEA     DI,IOARRAY
        MOV     AL,BYTE PTR DS:[BX+DI]
        MOV     i8080A,AL
        SUB     COUNTER,000Ah
        RET
OPDCh:                                  ; CC aa
        MOV     AL,i8080F
        AND     AL,00000001B
        JZ      OPDCNCarry
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPDCNCarry:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPDDh:                                  ; Invalid
        SUB     COUNTER,0004h
        RET
OPDEh:                                  ; SBI n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     DL,BYTE PTR ES:[BX]
        SBBREG  i8080A,DL,i8080F
        SZHPC   i8080F
        SUB     COUNTER,0007h
        RET
OPDFh:                                  ; RST 3
        MOV     BX,i8080SP
        MOV     AX,i8080PC
        INC     AX
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        MOV     AX,0018h
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPE0h:                                  ; RPO
        MOV     AL,i8080F
        AND     AL,00000100B
        JNZ     OPE0Even
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Bh
        RET
OPE0Even:
        SUB     COUNTER,0005h
        RET
OPE1h:                                  ; POP H
        MOV     BX,i8080SP
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080HL,AX
        INC     i8080SP
        INC     i8080SP
        SUB     COUNTER,000Ah
        RET
OPE2h:                                  ; JPO aa
        MOV     AL,i8080F
        AND     AL,00000100B
        JNZ     OPE2Even  
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPE2Even:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Ah
        RET
OPE3h:                                  ; XTHL
        MOV     BX,i8080SP
        MOV     AX,WORD PTR ES:[BX]
        MOV     CX,i8080HL
        MOV     i8080HL,AX
        WRITMEM CL
        INC     BX
        WRITMEM CH
        SUB     COUNTER,0012h
        RET
OPE4h:                                  ; CPO aa
        MOV     AL,i8080F
        AND     AL,00000100B
        JNZ     OPE4Even  
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPE4Even:  
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPE5h:                                  ; PUSH H
        MOV     BX,i8080SP
        MOV     AX,i8080HL
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        SUB     COUNTER,000Bh
        RET
OPE6h:                                  ; ANI n 
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        AND     i8080A,AL
        SZP     i8080F
        CLEARH  i8080F
        CLEARC  i8080F
        SUB     COUNTER,0007h
        RET
OPE7h:                                  ; RST 4
        MOV     BX,i8080SP
        MOV     AX,i8080PC
        INC     AX
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        MOV     AX,0020h
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPE8h:                                  ; RPE
        MOV     AL,i8080F
        AND     AL,00000100B
        JZ      OPE8Odd
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Bh
        RET
OPE8Odd:
        SUB     COUNTER,0005h
        RET
OPE9h:                                  ; PCHL
        MOV     AX,i8080HL
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,0005h
        RET
OPEAh:                                  ; JPE aa
        MOV     AL,i8080F
        AND     AL,00000100B
        JZ      OPEAOdd   
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPEAOdd:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Ah
        RET
OPEBh:                                  ; XCHG
        MOV     AX,i8080HL
        MOV     BX,i8080DE
        MOV     i8080HL,BX
        MOV     i8080DE,AX
        SUB     COUNTER,0004h
        RET
OPECh:                                  ; CPE aa
        MOV     AL,i8080F
        AND     AL,00000100B
        JZ      OPECOdd   
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPECOdd:  
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPEDh:                                  ; Invalid
        SUB     COUNTER,0004h
        RET
OPEEh:                                  ; XRI n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        XOR     i8080A,AL
        SZP     i8080F
        CLEARH  i8080F
        CLEARC  i8080F
        SUB     COUNTER,0007h
        RET
OPEFh:                                  ; RST 5
        MOV     BX,i8080SP
        MOV     AX,i8080PC
        INC     AX
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        MOV     AX,0028h
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPF0h:                                  ; RP
        MOV     AL,i8080F
        AND     AL,10000000B
        JNZ     OPF0Minus
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Bh
        RET
OPF0Minus:
        SUB     COUNTER,0005h
        RET
OPF1h:                                  ; POP PSW
        MOV     BX,i8080SP
        MOV     AX,WORD PTR ES:[BX]
        MOV     i8080AF,AX
        INC     i8080SP
        INC     i8080SP
        SUB     COUNTER,000Ah
        RET
OPF2h:                                  ; JP aa
        MOV     AL,i8080F
        AND     AL,10000000B
        JNZ     OPF2Minus 
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPF2Minus:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Ah
        RET
OPF3h:                                  ; DI
        MOV     IEN,00h
        SUB     COUNTER,0004h
        RET
OPF4h:                                  ; CP aa
        MOV     AL,i8080F
        AND     AL,10000000B
        JNZ     OPF4Minus 
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPF4Minus:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPF5h:                                  ; PUSH PSW
        MOV     BX,i8080SP
        MOV     AX,i8080AF
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        SUB     COUNTER,000Bh
        RET
OPF6h:                                  ; ORI n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     AL,BYTE PTR ES:[BX]
        OR      i8080A,AL
        SZP     i8080F
        CLEARC  i8080F
        CLEARH  i8080F
        SUB     COUNTER,0007h
        RET
OPF7h:                                  ; RST 6
        MOV     BX,i8080SP
        MOV     AX,i8080PC
        INC     AX
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        MOV     AX,0030h
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPF8h:                                  ; RM
        MOV     AL,i8080F
        AND     AL,10000000B
        JZ      OPF8Plus 
        RET8080 i8080SP,i8080PC
        SUB     COUNTER,000Bh
        RET
OPF8Plus:
        SUB     COUNTER,0005h
        RET
OPF9h:                                  ; SPHL
        MOV     AX,i8080HL
        MOV     i8080SP,AX
        SUB     COUNTER,0005h
        RET
OPFAh:                                  ; JM aa                                  
        MOV     AL,i8080F
        AND     AL,10000000B
        JZ      OPFAPlus  
        JMP8080 i8080PC
        SUB     COUNTER,000Ah
        RET
OPFAPlus:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Ah
        RET
OPFBh:                                  ; EI
        MOV     IEN,0FFh
        CMP     ISK,00h
        JE      @@NoWaiting
        MOV     EIINT,0FFh
        MOVZX   AX,IRQ
        PUSH    AX
        MOV     IRQ,00h
        CALL    DOINT
        POP     AX
        MOV     IRQ,AL
@@NoWaiting:
        MOV     EIINT,00h
        SUB     COUNTER,0004h
        RET
OPFCh:                                  ; CM aa
        MOV     AL,i8080F
        AND     AL,10000000B
        JZ      OPFCPlus  
        CLL8080 i8080SP,i8080PC
        SUB     COUNTER,0011h
        RET
OPFCPlus:
        INC     i8080PC
        INC     i8080PC
        SUB     COUNTER,000Bh
        RET
OPFDh:                                  ; Invalid
        SUB     COUNTER,0004h
        RET                     
OPFEh:                                  ; CPI n
        INC     i8080PC
        MOV     BX,i8080PC
        MOV     DL,BYTE PTR ES:[BX]
        CMPREG  i8080A,DL,i8080F
        SUB     COUNTER,0007h
        RET
OPFFh:                                  ; RST 7
        MOV     BX,i8080SP
        MOV     AX,i8080PC
        INC     AX
        DEC     BX
        WRITMEM AH
        DEC     BX
        WRITMEM AL
        DEC     i8080SP
        DEC     i8080SP
        MOV     AX,0038h
        MOV     i8080PC,AX
        DEC     i8080PC
        SUB     COUNTER,000Bh
        RET
DECODE  ENDP

RR      PROC    NEAR
        MOV     CX,ROMNUM
        LEA     BX,RNAME
        LEA     DI,RLOC
@@ReadRoms:
        MOV     AX,RSIZE
        PUSH    AX
        PUSH    BX
        MOV     AX,WORD PTR[DI]
        PUSH    AX
        LEA     AX,NOEXIST
        PUSH    AX
        LEA     AX,SHORTER
        PUSH    AX
        LEA     AX,ERRORO
        PUSH    AX
        LEA     AX,TEMPBYT
        PUSH    AX
        CALL    READROM
        ADD     SP,000Eh
        ADD     BX,000Dh
        ADD     DI,0002h
        LOOP    @@ReadRoms
        RET
RR      ENDP

READROM PROC    NEAR
        PUSH    BP
        MOV     BP,SP
@@TempC EQU     [BP+04h]
@@OErr  EQU     [BP+06h]
@@Shrtr EQU     [BP+08h]
@@No    EQU     [BP+0Ah]
@@RAddy EQU     [BP+0Ch]
@@FName EQU     [BP+0Eh]
@@FSize EQU     [BP+10h]
@@FHndl EQU     [BP-02h]
@@ECode EQU     [BP-04h]
@@Bytes EQU     [BP-06h]
        SUB     SP,0008h
        PUSH    BX
        PUSH    CX
        PUSH    DX
        PUSH    DI
        MOV     AH,3Dh
        MOV     AL,00h                  
        MOV     DX,@@FName           
        MOV     CL,00h           
        INT     21h

        JNC     GotIt
        MOV     AH,09h
        MOV     DX,@@No
        INT     21h
        ENDPROG
GotIt:
        MOV     @@FHndl,AX
        MOV     DI,@@RAddy
        MOV     DX,0000h
GetIt:
        PUSH    DX
        MOV     AH,3Fh                  ; Request file or device read
        MOV     BX,@@FHndl
        MOV     CX,0001h
        MOV     DX,@@TempC
        INT     21h
        JC      BadErr

        CMP     AX,0001h
        JE      Cont
        MOV     AH,09h

        MOV     DX,@@Shrtr
        INT     21h
        ENDPROG
BadErr:
        MOV     AH,09h
        MOV     DX,@@OErr
        INT     21h
Cont:
        MOV     BX,@@TempC
        MOV     AL,BYTE PTR DS:[BX]
        MOV     BYTE PTR ES:[DI],AL
        POP     DX
        INC     DX
        INC     DI
        CMP     DX,@@FSize
        JE      Done
        JMP     GetIt
Done:
        MOV     AX,DI
        POP     DI
        POP     DX
        POP     CX
        POP     BX
        ADD     SP,0008h
        POP     BP
        RET
READROM ENDP

INTASC  PROC    NEAR
        LOCALS
        PUSH    BP
        MOV     BP,SP
@@Asc   EQU     [BP+04h]
@@Int   EQU     [BP+06h]
        PUSHA
        MOV     CX,0004h
        MOV     SI,@@Asc
        ADD     SI,0003h
@@FillZero:
        MOV     BYTE PTR[SI],30h
        DEC     SI
        LOOP    @@FillZero
        MOV     BX,@@Int
        MOV     CX,0010h
        MOV     SI,@@Asc
        ADD     SI,0003h
        MOV     AX,WORD PTR[BX]
@@ConvertIt:
        CMP     AX,CX
        JB      @@DoneConvert
        XOR     DX,DX
        DIV     CX
        CMP     DL,09h
        JA      @@HexConv
        OR      DL,30h
        MOV     [SI],DL
        DEC     SI
        JMP     @@ConvertIt
@@HexConv:
        ADD     DL,37h
        MOV     [SI],DL
        DEC     SI
        JMP     @@ConvertIt
@@DoneConvert:
        CMP     AL,09h
        JA      @@HexDone
        OR      AL,30h
        MOV     [SI],AL
        POPA
        POP     BP
        RET
@@HexDone:
        ADD     AL,37h
        MOV     [SI],AL
        POPA
        POP     BP
        RET
INTASC  ENDP

DREGS   PROC    NEAR
        PDIS    REGS,00h,00h        
        LEA     AX,i8080PC
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,00h,03h

        MOV     AH,i8080A
        MOV     AL,i8080F
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,00h,0Dh

        MOV     AH,i8080B
        MOV     AL,i8080C
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,00h,17h

        MOV     AH,i8080D
        MOV     AL,i8080E
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,00h,21h

        MOV     AH,i8080H
        MOV     AL,i8080L
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,01h,03h

        MOV     AX,i8080SP
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,01h,0Dh

        MOV     AL,OP
        MOV     AH,00h
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,01h,17h

        MOV     EAX,COUNTER
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,01h,21h

        MOV     AL,IEN
        MOV     AH,00h
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,02h,03h

        MOV     AL,IRQ
        MOV     AH,00h
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,02h,0Dh

        MOV     AL,ISK
        MOV     AH,00h
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,02h,17h

        MOV     AL,HALTED
        MOV     AH,00h
        MOV     TEMPWRD,AX
        LEA     AX,TEMPWRD
        PUSH    AX
        LEA     AX,ASCNUM
        PUSH    AX
        CALL    INTASC
        ADD     SP,0004h
        PDIS    ASCNUM,02h,21h
        RET
DREGS   ENDP

UPDATE  PROC    NEAR
        MOV     CX,00E0h
        MOV     BX,2400h
        MOV     AX,0A000h
        MOV     FS,AX
        MOV     DI,0000h
@@DoUpdate:
        MOV     DH,00h
        MOV     DL,20h
@@DrawScan:
        PUSH    DX
        PUSH    BX
        MOVZX   BX,BYTE PTR ES:[BX]
        ADD     BX,OFFSET REVTABL
        MOV     DL,BYTE PTR[BX]
        POP     BX
        MOV     BYTE PTR FS:[DI],DL
        POP     DX
        INC     DI
        INC     BX
        DEC     DL
        JZ      @@DoneScan
        JMP     @@DrawScan
@@DoneScan:
        ADD     DI,0030h
        LOOP    @@DoUpdate
        RET
UPDATE  ENDP

DOINT   PROC    NEAR
        LOCALS
        CMP     IEN,00h
        JE      @@PushInt
        CMP     HALTED,00h
        JE      @@ContInt
        INC     i8080PC
        MOV     HALTED,00h
@@ContInt:
        CMP     ISK,00h
        JE      @@CallInt
        MOV     AL,ISK
        MOV     AH,IRQ
        MOV     ISK,AH
        MOV     IRQ,AL
@@CallInt:
        MOV     BX,i8080SP
        MOV     CX,i8080PC
        MOV     BYTE PTR ES:[BX-1],CH
        MOV     BYTE PTR ES:[BX-2],CL
        MOVZX   AX,IRQ
        MOV     i8080PC,AX
        DEC     i8080SP
        DEC     i8080SP
        CMP     EIINT,00h
        JE      @@NotAnEI
        DEC     i8080PC
@@NotAnEI:
        RET
@@PushInt:
        MOV     AL,IRQ
        MOV     ISK,AL
        RET
DOINT   ENDP

GETHEDR PROC    NEAR        
        SDIS    INSTRUC
        MOV     BX,0080h
        MOV     AH,BYTE PTR ES:[BX]
        OR      AH,AH
        JNZ     GotHName
        SDIS    NOFILEN
        ENDPROG
GotHName:
        INC     BX
        INC     BX
        DEC     AH
        LEA     DI,HDRNAME
        MOV     AL,0Ch
GetHeader:
        MOV     CL,BYTE PTR ES:[BX]
        CMP     CL,0Dh
        JE      InitNum
        MOV     BYTE PTR DS:[DI],CL
        
        INC     BX
        INC     DI
        DEC     AH
        JZ      InitNum

        DEC     AL
        JZ      TooLong
        JMP     GetHeader
InitNum:
        RET
TooLong:
        SDIS    F2LONG
        ENDPROG
GETHEDR ENDP

READHDR PROC    NEAR
        MOV     AH,3Dh
        MOV     AL,00h                  
        LEA     DX,HDRNAME           
        MOV     CL,00h           
        INT     21h
        JNC     LoadedHName

        SDIS    NOHEADR
        ENDPROG
LoadedHName:
        MOV     HHANDLE,AX
        LEA     DI,RNAME
        MOV     DX,0000h
GetHeaderData:
        PUSH    DX
        MOV     AH,3Fh                  ; Request file or device read
        MOV     BX,HHANDLE
        MOV     CX,0001h
        LEA     DX,TEMPBYT
        INT     21h
        JC      BadErr

        CMP     AX,0001h
        JE      ContinueLoad
        SDIS    HDRSHRT
        ENDPROG
ContinueLoad:
        MOV     AL,TEMPBYT
        MOV     BYTE PTR DS:[DI],AL
        POP     DX
        INC     DX
        INC     DI
        CMP     DX,015Eh
        JE      GetBitmapIn 
        JMP     GetHeaderData
GetBitmapIn:        
        MOV     AH,3Fh                  ; Request file or device read
        MOV     BX,HHANDLE
        MOV     CX,0001h
        LEA     DX,TEMPBYT
        INT     21h
        JC      BadErr

        CMP     AX,0001h
        JE      GetBitmapOut
        SDIS    HDRSHRT
        ENDPROG
GetBitmapOut:
        MOV     AL,TEMPBYT
        MOV     BTMPIN,AL
        MOV     AH,3Fh                  ; Request file or device read
        MOV     BX,HHANDLE
        MOV     CX,0001h
        LEA     DX,TEMPBYT
        INT     21h
        JC      BadErr

        CMP     AX,0001h
        JE      GetShiftOut
        SDIS    HDRSHRT
        ENDPROG
GetShiftOut:
        XOR     AX,AX
        MOV     AL,TEMPBYT
        MOV     BTMPOUT,AX
        MOV     AH,3Fh                  ; Request file or device read
        MOV     BX,HHANDLE
        MOV     CX,0001h
        LEA     DX,TEMPBYT
        INT     21h
        JC      BadErr

        CMP     AX,0001h
        JE      DoneHeader
        SDIS    HDRSHRT
        ENDPROG
DoneHeader:
        XOR     AX,AX
        MOV     AL,TEMPBYT
        MOV     SHFTOUT,AX
        RET
READHDR ENDP
        END     MAIN
